declare type FilterString<T> = T extends string ? T : never;
export declare type SelectorPaths<T> = FilterString<keyof {
    [K in FilterString<keyof NonNullable<T>> as K | (NonNullable<T>[K] extends Record<string, unknown> | undefined | null ? `${K}.${SelectorPaths<NonNullable<T>[K]>}` : never)]: 1;
}>;
declare type Value<T, K> = K extends keyof T ? T[K] : K extends keyof NonNullable<T> ? NonNullable<T>[K] | undefined : undefined;
export declare type SelectorValue<T, K> = K extends `${infer K}.${infer Rest}` ? SelectorValue<Value<T, K>, Rest> : Value<T, K>;
export declare function createSelector<T, S>(stringSelector: string): (state: T) => S;
export declare function setWithSelector(state: unknown, stringSelector: string, value: unknown): void;
export {};
