import { Context, ReactNode } from 'react';
import { SelectorPaths, SelectorValue } from '../helpers/stringSelector';
import { Store } from './store';
import { UseStorePropResult } from './useStoreProp';
import { UseStoreStateOptions } from './useStoreState';
export declare class StoreScope<T> {
    readonly defaultValue: T;
    readonly context: Context<Store<T>>;
    constructor(defaultValue: T);
    Provider: ({ children, store }: {
        children: ReactNode;
        store?: Store<T> | undefined;
    }) => JSX.Element;
    withScope: <Args extends Record<string, unknown>>(Component: (args: Args) => JSX.Element) => (args: Args) => JSX.Element;
    useStore(): Store<T>;
    useState(options?: UseStoreStateOptions): T;
    useState<S>(selector: (state: T) => S, dependencies?: any[], options?: UseStoreStateOptions): S;
    useState<K extends SelectorPaths<T>>(selector: K, options?: UseStoreStateOptions): SelectorValue<T, K>;
    useProp<K extends SelectorPaths<T>>(selector: K): UseStorePropResult<T, K>;
}
